#include <gtk/gtk.h>
#include <glade/glade.h>
#include <libxml/tree.h>
#include "kf.h"
#include "jabber.h"
#include "archive_viewer.h"

/* Local function prototypes */

static void load_data (void);
static void load_data_file (const gchar *name);

/* Data */

static GList *chatsi	= NULL;
static GList *msgs_in	= NULL;
static GList *msgs_out	= NULL;

/* Functions */

void kf_archive_viewer (void) {
	load_data ();
}

/* Loads archive data into memory */
static void load_data (void) {
	GDir *dir;
	const gchar *file;
	const gchar *path;

	path = kf_config_file ("archive");

	dir = g_dir_open (path, 0, NULL);
	g_return_if_fail (dir);

	while (file = g_dir_read_name (dir)) {
		gchar *filename;

		filename = g_strdup_printf ("%s/%s", path, file);
		load_data_file (filename);
		g_free (filename);
	}

	g_dir_close (dir);
}

/* Loads data from filename xml file */
static void load_data_file (const gchar *name) {
	xmlDocPtr doc = NULL;
	xmlNodePtr node;

	


/*	doc = xmlParseFile (name);
	if (doc == NULL) {
		xmlFreeDoc (doc);
		return;
	}

	node = xmlDocGetRootElement (doc);
	if (node == NULL) {
		xmlFreeDoc (doc);
		return;
	}
	*/
            FILE *f;
	g_print (" * reading '%s'\n", name);

            f = fopen(name, "r");
            if (f != NULL) {
                int res, size = 1024;
                char chars[1024];
                xmlParserCtxtPtr ctxt;

           //     res = fread(chars, 1, 4, f);
        //        if (res > 0) {
                    //ctxt = xmlCreatePushParserCtxt(NULL, NULL,
                    //            chars, res, NULL);
                    ctxt = xmlCreatePushParserCtxt(NULL, NULL,
                                NULL, 0, NULL);
                    xmlParseChunk(ctxt, "<archive>", 9, 0);
                    while ((res = fread(chars, 1, size, f)) > 0) {
//			    g_print ("chunk:\n%.1024s\n", chars);
                        xmlParseChunk(ctxt, chars, res, 0);
                    }
                    xmlParseChunk(ctxt, chars, 0, 1);
                    xmlParseChunk(ctxt, "</archive>", 10, 0);
                    doc = ctxt->myDoc;
                    xmlFreeParserCtxt(ctxt);
          //      }
            }

	if (doc) {
    node = xmlDocGetRootElement(doc);
    node = node->children;
	for (; node; node = node->next) {
		g_print ("   * message <%s> stamp %s\n" ,node->name, xmlGetProp (node, "kf::stamp"));
	}
	}
}
