#include <gtk/gtk.h>
#include <glade/glade.h>
#include "callbacks.h"
#include "jabber.h"
#include "gui.h"
#include "new_message.h"

static void status_selected (GtkMenuItem *menuitem);


gboolean    on_main_window_delete_event    (GtkWidget *widget,
                                            GdkEvent *event,
                                            gpointer user_data)
{
	gtk_main_quit ();
	return TRUE;
}

void        on_status_available_activate   (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_gui_change_status (NULL); 
//	status_selected (menuitem);
//	kf_jabber_send_presence (NULL, NULL); 
}

void        on_status_away_activate        (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_gui_change_status ("away"); 
//	status_selected (menuitem);
//	kf_jabber_send_presence ("away", NULL); 
}

void        on_status_xa_activate          (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_gui_change_status ("xa"); 
//	status_selected (menuitem);
//	kf_jabber_send_presence ("xa", NULL); 
}

void        on_status_chatty_activate      (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_gui_change_status ("chat"); 
//	status_selected (menuitem);
//	kf_jabber_send_presence ("chat", NULL); 
}

void        on_status_dnd_activate         (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_gui_change_status ("dnd"); 
//	status_selected (menuitem);
//	kf_jabber_send_presence ("dnd", "Do not Disturb!"); 
}

void        on_status_invisible_activate   (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_gui_change_status ("invisible"); 
//	status_selected (menuitem);
//	kf_jabber_send_presence ("invisible", NULL); 
}

void        on_status_disconnect_activate(GtkMenuItem *menuitem,
                                            gpointer user_data)
{
//	kf_gui_change_status ("unavailable"); 
	status_selected (menuitem);
	//kf_jabber_send_presence ("unavailable", NULL); 
	kf_jabber_disconnect ();
}

void        on_status_disconnect_x_activate(GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_gui_change_status ("unavailable"); 
//	status_selected (menuitem);
	//kf_jabber_send_presence ("unavailable", NULL); 
//	kf_jabber_disconnect ();
}


static void status_selected (GtkMenuItem *menuitem) {
	GtkLabel *label;
	GtkImage *image;
	const gchar *text;
	GdkPixbuf *pixbuf;
	GtkImage *status;
	GtkMenuItem *item1;
	GtkLabel *item1_label;
	extern GladeXML *iface;
	
	label = GTK_LABEL (gtk_bin_get_child (GTK_BIN (menuitem)));
	text = gtk_label_get_text (label);
	
	image = GTK_IMAGE (gtk_image_menu_item_get_image (GTK_IMAGE_MENU_ITEM (menuitem)));
	pixbuf = gtk_image_get_pixbuf (image);

	status = GTK_IMAGE (glade_xml_get_widget (iface, "my_status_image"));
	item1 = GTK_MENU_ITEM (glade_xml_get_widget (iface, "menuitem1"));
	item1_label = GTK_LABEL (gtk_bin_get_child (GTK_BIN (item1)));
	
	gtk_image_set_from_pixbuf (status, pixbuf);
	gtk_label_set_text (item1_label, text);

	g_print ("->[%s]<-\n", text);
	
//	g_free (text);
}

/* Obsuga "> Zaawansowane" w oknie ustawie poczenia */
/*
gboolean    on_connection_eventbox_button_press_event (GtkWidget *widget,
                                            GdkEventButton *event,
                                            gpointer user_data)
{
	extern GladeXML *iface;
	GtkWidget *frame, *arrow;

	frame = glade_xml_get_widget (iface, "connection_frame");
	arrow = glade_xml_get_widget (iface, "arrow1");
	if (!GTK_WIDGET_VISIBLE (frame)) {
		gtk_widget_show (frame);
		gtk_arrow_set (GTK_ARROW (arrow), GTK_ARROW_DOWN, GTK_SHADOW_OUT);
	} else {
		GtkWidget *window;

		window = glade_xml_get_widget (iface, "connection_settings_window");
		gtk_widget_hide (frame);
		gtk_window_resize (GTK_WINDOW (window), 1, 1);
		gtk_arrow_set (GTK_ARROW (arrow), GTK_ARROW_RIGHT, GTK_SHADOW_OUT);
	}
}
*/
/* Zamknicie okna ustawie poczenia */
/*
gboolean    on_connection_settings_window_delete_event (GtkWidget *widget,
                                            GdkEvent *event,
                                            gpointer user_data)
{
	gtk_widget_hide (widget);
	return TRUE;
}
*/
/* Guzik "Pomoc" w oknie ustawie poczenia */
void        on_connection_help_clicked     (GtkButton *button,
                                            gpointer user_data)
{
}

/*
void        on_connection_quit_clicked     (GtkButton *button,
                                            gpointer user_data)
{
}

void        on_connection_ok_clicked       (GtkButton *button,
                                            gpointer user_data)
{
	extern GladeXML *iface;
	GtkWidget *entry, *window;
	const gchar *server, *username, *password, *resource; 
	gint port;

	entry = glade_xml_get_widget (iface, "connection_server");
	server = gtk_entry_get_text (GTK_ENTRY (entry));
	entry = glade_xml_get_widget (iface, "connection_username");
	username = gtk_entry_get_text (GTK_ENTRY (entry));
	entry = glade_xml_get_widget (iface, "connection_password");
	password = gtk_entry_get_text (GTK_ENTRY (entry));
	entry = glade_xml_get_widget (iface, "connection_resource");
	resource = gtk_entry_get_text (GTK_ENTRY (entry));
	entry = glade_xml_get_widget (iface, "connection_port");
	port = gtk_spin_button_get_value (GTK_SPIN_BUTTON (entry));

	kf_jabber_set_connection (server, username, password, resource, port);
	kf_jabber_connect();

	gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));
	window = glade_xml_get_widget (iface, "main_window");
	gtk_widget_show (window);
}
*/
/*
void        on_connection_dodaj_konto_clicked (GtkButton *button,
                                            gpointer user_data)
{
}
*/
void        on_menu_new_msg_activate       (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_connected ();
	kf_new_message (NULL);
}

void        on_menu_quit_activate          (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	gtk_main_quit ();
}


void        on_menu_prefs_activate         (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_settings ();
}

void        on_menu_vcard_activate         (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_connected ();
	kf_vcard_my ();
}


void        on_menu_groupchat_activate     (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
}


void        on_menu_add_contact_activate   (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	GtkWidget *win;
	extern GladeXML *iface;

	kf_connected ();
	win = glade_xml_get_widget (iface, "add_contact_window");
	kf_gui_show (win);
}


void        on_menu_info_activate          (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	GtkWidget *win;
	extern GladeXML *iface;

	win = glade_xml_get_widget (iface, "info_window");
	kf_gui_show (win);
}

void        on_menu_xml_activate           (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	GtkWidget *win;
	extern GladeXML *iface;

	kf_connected ();
	win = glade_xml_get_widget (iface, "xml_console");
	kf_gui_show (win);
}


void        on_menu_show_offline_activate  (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
/*	GtkWidget *win;
	extern GladeXML *iface;

	win = glade_xml_get_widget (iface, "xml_console");
	kf_gui_show (win);*/
	kf_gui_toggle_show_offline ();
//	gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (menuitem), kf_gui_toggle_show_offline ());
}


void        on_menu_show_toolbar_activate  (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	GtkWidget *toolbar;
	extern GladeXML *iface;

	toolbar = glade_xml_get_widget (iface, "handlebox3");
	if (GTK_WIDGET_VISIBLE (toolbar)) {
		kf_preferences_set_int ("showToolbar", (gint) FALSE);
		gtk_widget_hide (toolbar);
	} else {
		kf_preferences_set_int ("showToolbar", (gint) TRUE);
		gtk_widget_show (toolbar);
	}
}




/* Zamknicie okna ustawie poczenia */
gboolean    on_any_window_delete_event    (GtkWidget *widget,
                                            GdkEvent *event,
                                            gpointer user_data)
{
	g_print ("Chowam okno...");
	gtk_widget_hide (widget);
	return TRUE;
}

void        on_any_close_window_clicked    (GtkButton *button,
                                            gpointer user_data)
{
	gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));
}

void close_window                          (GtkButton *button,
                                            gpointer user_data)
{
	gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET (button)));
}

 

gboolean    on_roster_tree_view_select_cursor_row (GtkTreeView *treeview,
                                            gboolean arg1,
                                            gpointer user_data) {
	g_print ("select-cursor-row\n");
	return TRUE;
}

void       on_roster_tree_view_row_activated (GtkTreeView *treeview,
                                            GtkTreePath *arg1,
                                            GtkTreeViewColumn *arg2,
                                            gpointer user_data) {
	g_print ("row-activated\n");
}

/*
 * Obsuga prawego kliknicia
 */
gboolean    on_roster_tree_view_button_release_event (GtkWidget *widget,
                                            GdkEventButton *event,
                                            gpointer user_data)
{
//	GtkTreeSelection *select;
//	gchar *jid = NULL;
///
//	/* Odczytujemy zaznaczenie z listy */
//	select = gtk_tree_view_get_selection (GTK_TREE_VIEW (widget));
//
//	if (select) {
//		GtkTreeIter iter;
//		GtkTreeModel *model;
//
//		if (gtk_tree_selection_get_selected (GTK_TREE_SELECTION (select), &model, &iter)) {
//			gtk_tree_model_get (model, &iter, 1, &jid, -1);
//		}
//	}
//		
//	/* Sprawdmy, czy kliknito 3 klawiszem */
//	if (jid && event->type == GDK_BUTTON_RELEASE && event->button == 3) {
//		extern GladeXML *iface;
//		GtkWidget *menu;
//
//		if (jid->type == 
//		menu = glade_xml_get_widget (iface, "roster_popup_menu");
//		gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL, 0, event->time);
//	}
//	return FALSE;

	return FALSE;
}

/*
 * Obsuga m.in. lewego kliknicia
 */
gboolean    on_roster_tree_view_button_press_event (GtkWidget *widget,
                                            GdkEventButton *event,
                                            gpointer user_data)
{
//	GtkTreeSelection *select;
//	gchar *jid = NULL;
//	GtkTreeIter iter;
//	GtkTreeModel *model;
//	KfJabberRosterItem *item;
//
//	/* Odczytujemy zaznaczenie z listy */
//	select = gtk_tree_view_get_selection (GTK_TREE_VIEW (widget));
//
//	if (select) {
//		if (gtk_tree_selection_get_selected (GTK_TREE_SELECTION (select), &model, &iter)) {
//			gtk_tree_model_get (model, &iter, 1, &jid, 2, &item, -1);
//		}
//	}
//		
//	/* Sprawdmy, czy kliknito 3 klawiszem */
//	if (event->type == GDK_2BUTTON_PRESS && event->button == 1) {
//		if (jid) {
//			if (item && item->fulljid) {
//				if (kf_preferences_get_int ("messageDefault"))
//					kf_new_message (item->fulljid);
//				else
//					kf_chat_window (item->fulljid);
//			}
//		} else {
//			GtkTreePath *path;
//
//			path = gtk_tree_model_get_path (model, &iter);
//			if (gtk_tree_view_row_expanded (GTK_TREE_VIEW (widget), path)) {
//				gtk_tree_view_collapse_row (GTK_TREE_VIEW (widget), path);
//			} else {
//				gtk_tree_view_expand_row (GTK_TREE_VIEW (widget), path, FALSE);
//			}
//			gtk_tree_path_free (path);
//		}
//	}
//	return FALSE;
	GtkTreeView *view = (GtkTreeView *) widget;
	GtkTreePath *path;
	GtkTreeIter iter;
	GtkTreeModel *model;
	gchar *jid, *label;
	KfJabberRosterItem *item;

	if (event->window == gtk_tree_view_get_bin_window (view) &&
		gtk_tree_view_get_path_at_pos (view, event->x, event->y,  &path, NULL,
			NULL, NULL)) {
		/* W miejscu kliknicia jest co */
		model = gtk_tree_view_get_model (view);

		if (!gtk_tree_model_get_iter (model, &iter, path))
			return FALSE;

		gtk_tree_model_get (model, &iter, 0, &label, 1, &jid, 2, &item, -1);
//		gtk_tree_model_get (model, &iter, 0, &label, -1);
//		g_print ("Klik na %s, '%s' <%s:%s>\n", label, (jid)?item->display_name:"grupa",
//				(jid)?item->jid:"grupa", (jid)?item->fulljid:"grupa");
//		if (jid)
//			g_print ("Wybrano %s:%s\n", item->display_name,
//					kf_jabber_presence_type_to_string (item->presence));

		/* To wszystko na pocztek */
		
		if (jid && event->type == GDK_BUTTON_PRESS && event->button == 3) {
			/* Kliknicie 3 klawiszem na kontakcie */
			extern GladeXML *iface;
			GtkWidget *menu;

			if (item->type == KF_JABBER_CONTACT_TYPE_CONTACT) 
				menu = glade_xml_get_widget (iface, "roster_popup_menu");
			else
				menu = glade_xml_get_widget (iface, "roster_popup_agent_menu");

			kf_popup_groups_menu_attach (iface, item);

			gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL, 0, event->time);

		} else if (event->type == GDK_2BUTTON_PRESS && event->button == 1) {
			/* Podwjne kliknicie 1 guzikiem */
			if (jid && item && item->fulljid) {
				/* To jest jaki tam kontakt */
				if (kf_preferences_get_int ("messageDefault"))
					kf_new_message (item->fulljid);
				else
					kf_chat_window (item->fulljid);

			} else if (!jid) {
				/* Grupa */
				if (gtk_tree_view_row_expanded (GTK_TREE_VIEW (widget), path)) {
					gtk_tree_view_collapse_row (GTK_TREE_VIEW (widget), path);
				} else {
					gtk_tree_view_expand_row (GTK_TREE_VIEW (widget), path, FALSE);
				}
			}
		}
		gtk_tree_path_free (path);
	}
	return FALSE;
}


void        on_xml_send_clicked            (GtkButton *button,
                                            gpointer user_data)
{
	extern GladeXML *iface;
	GtkWidget *tv;		/* . */
	GtkTextBuffer *buffer;	/* . */
	GtkTextIter start, end;
	gchar *body, *status;
	
	kf_connected ();
	/* Pobranie treci wiadomoci */
	tv = glade_xml_get_widget (iface, "xml_console_text_view");
	if (tv == NULL)
		g_error ("Ni mo widoku na tekst!\n");
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (tv));
	gtk_text_buffer_get_bounds (buffer, &start, &end);
	body = gtk_text_buffer_get_text (buffer, &start, &end, FALSE);
	gtk_text_buffer_delete (buffer, &start, &end);

	g_print ("< %s\n", body);

	kf_jabber_send_raw (body);

	g_free (body);
}

void        on_add_contact_ok_clicked      (GtkButton *button,
                                            gpointer user_data)
{
	extern GladeXML *iface;
	GtkWidget *entry, *window;
	const gchar *jid, *name, *group;
	gboolean subscribe = TRUE;

	kf_connected ();
	entry = glade_xml_get_widget (iface, "add_jid");
	jid = gtk_entry_get_text (GTK_ENTRY (entry));
	entry = glade_xml_get_widget (iface, "add_name");
	name = gtk_entry_get_text (GTK_ENTRY (entry));
	entry = glade_xml_get_widget (iface, "add_group");
	group = gtk_entry_get_text (GTK_ENTRY (entry));
	entry = glade_xml_get_widget (iface, "add_subscription");
	subscribe = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (entry));

	kf_jabber_add_contact (jid, name, group, subscribe);

//	g_free (jid);
//	g_free (name);
//	g_free (group);
	
	gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));
	g_print ("");
}

void        on_button_add_contact_clicked       (GtkButton *button,
                                            gpointer user_data)
{
	kf_connected ();
	kf_gui_add_contact (NULL);
}


void        on_button_browse_clicked       (GtkButton *button,
                                            gpointer user_data)
{
	kf_connected ();
	kf_browse_window ();
}


void        on_button_search_clicked       (GtkButton *button,
                                            gpointer user_data)
{
	kf_connected ();
	kf_search_window ();
}

void        on_button_register_clicked       (GtkButton *button,
                                            gpointer user_data)
{
	kf_connected ();
	kf_register_window ();
}

void        on_menu_browse_activate        (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_connected ();
	kf_browse_window ();
}

void        on_menu_search_activate        (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_connected ();
	kf_search_window ();
}

void        on_menu_register_activate      (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_connected ();
	kf_register_window ();
}


void        on_change_password_activate        (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_connected ();
	kf_change_password ();
}





void kf_gui_add_contact (const gchar *jid) {
	GtkWidget *win;
	extern GladeXML *iface;
	GtkWidget *combo;

	kf_connected ();
	win = glade_xml_get_widget (iface, "add_contact_window");
	if (jid) {
		GtkWidget *entry;

		entry = glade_xml_get_widget (iface, "add_jid");
		gtk_entry_set_text (GTK_ENTRY (entry), jid);
	}
        combo = glade_xml_get_widget (iface, "combo1");
        gtk_combo_set_popdown_strings (GTK_COMBO (combo), kf_gui_get_groups ());
	kf_gui_show (win);
}
