#include <gtk/gtk.h>
#include <glade/glade.h>
#include "kf.h"
#include "gui.h"
#include "jabber.h"

void        on_popup_message_activate      (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_new_message (kf_gui_get_selected_jid ());
}

void        on_popup_chat_activate         (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_chat_window (kf_gui_get_selected_jid ());
}

void        on_popup_delete_activate       (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_jabber_remove_contact (kf_gui_get_selected_jid ());
}

void        on_popup_info_activate         (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_vcard_get (kf_gui_get_selected_jid ());
}

/* Presence */
void        on_popup_presence_activate    (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
//	g_print ("------------------------------> %s\n", user_data);
//	if (user_data)
		kf_jabber_send_presence_to_jid (user_data, kf_gui_get_selected_jid ());
}

void        on_popup_log_in_activate       (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_jabber_send_presence_to_jid (NULL, kf_gui_get_selected_jid ());
}
void        on_popup_log_out_activate      (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	kf_jabber_send_presence_to_jid ("unavailable", kf_gui_get_selected_jid ());
}

/* Activates history window */
void        on_popup_history_activate      (GtkMenuItem *menuitem,
                                            gpointer user_data)
{
	/* Since there is no history window, we'll launch a terminal with less
	 * showing log file:-) */
	gchar *jidx;
	gchar *file;

	jidx = g_strdup (kf_gui_get_selected_jid ());
	kf_jabber_jid_crop (jidx);

	file = g_strdup_printf ("%s/%s.txt", kf_config_file ("log"), jidx);
	if (!g_file_test (kf_config_file ("log"), G_FILE_TEST_EXISTS)) {
		g_printerr ("There's no file...\n");
	} else {
		gchar *cmd;

		cmd = g_strdup_printf ("rxvt -e less \"%s\" &", file);
		system (cmd);
		g_free (cmd);
	}

	g_free (jidx);
	g_free (file);
}
